local P1, P2, P1Score, P2Score
local difficulty, sTable
local songName= GAMESTATE:GetCurrentSong():GetSongDir() -- Looks for Song

local WideScale = function(AR4_3, AR16_9)
	-- return scale( SCREEN_WIDTH, 640, 854, AR4_3, AR16_9 )
	local w = 480 * PREFSMAN:GetPreference("DisplayAspectRatio")
	return scale( w, 640, 854, AR4_3, AR16_9 )
 end

local function Handler_mod_internal(str, pn) -- Applies Players options to not be disabled-
	local ps= GAMESTATE:GetPlayerState(pn)
	local pmods= ps:GetPlayerOptionsString('ModsLevel_Song')
	ps:SetPlayerOptions('ModsLevel_Song', pmods .. ', ' .. str)
	--GAMESTATE:ApplyGameCommand('mod,'..str, pn)
end


local function isEditMode()
	for _,player in ipairs(GAMESTATE:GetHumanPlayers()) do
		if (GAMESTATE:GetCurrentSteps(player):GetDifficulty() == "Difficulty_Edit") then
			return true;
		end
	end
	return false;
end
local function setEditChart()
	sTable = GAMESTATE:GetCurrentSong():GetStepsByStepsType( "StepsType_Dance_Single" );
	for _,player in ipairs(GAMESTATE:GetHumanPlayers()) do
		if (GAMESTATE:GetCurrentSteps(player):GetDifficulty() == "Difficulty_Challenge" or GAMESTATE:GetCurrentSteps(player):GetDifficulty() == "Difficulty_Hard") then
			GAMESTATE:SetCurrentSteps(player,sTable[2])
			SCREENMAN:SetNewScreen('ScreenGameplay')
		end
	end
end

local function Handler_mod(str) -- Looks for many players are on the screen 
	if (isEditMode()) then return end
	for i=1,2 do
		Handler_mod_internal(str, 'PlayerNumber_P' .. i)
	end
end

local function Handler_init() -- Useful for command shorcuts
	if (isEditMode()) then
		setEditChart()
		return;
	end
	if SCREENMAN:GetTopScreen():GetChild('PlayerP1') and not isEditMode() then
		P1 = SCREENMAN:GetTopScreen():GetChild('PlayerP1')
		P1:visible(false)
	end
	if SCREENMAN:GetTopScreen():GetChild('PlayerP2') and not isEditMode() then
		P2 = SCREENMAN:GetTopScreen():GetChild('PlayerP2')
		P2:visible(false)
	end
	if SCREENMAN:GetTopScreen():GetChild('Underlay'):GetChild('P1Score') and not isEditMode() then
		P1Score = SCREENMAN:GetTopScreen():GetChild('Underlay'):GetChild('P1Score')
	end
	if SCREENMAN:GetTopScreen():GetChild('Underlay'):GetChild('P2Score')and not isEditMode() then
		P2Score = SCREENMAN:GetTopScreen():GetChild('Underlay'):GetChild('P2Score')
	end


	fgcurcommand = 0;
	wndr_skewx=0.3;
	checked = false;
	--lua course :D	/ timed mod management	
	curmod = 1;		
	--{beat,'mod'},
	mods = {
		{111.5,'*1 95% dark, *2 80% stealth, *1 100% Beat'},
		{112.25,'*1 no dark, *1 no stealth, *1 no Blink'},
		{143.5,'*1 95% dark, *2 80% stealth,'},
		{144.25,'*1 no dark, *1 no stealth, *1 no Blink'},
		{175.5, '*1 no Beat'},
		{303.5,'*1 95% dark, *2 80% stealth, *5 80% Beat'},
		{304.5,'*1 no dark, *1 no stealth, *1 no Blink'},
		{335.5,'*1 95% dark, *2 80% stealth,'},
		{336.25,'*1 no dark, *1 no stealth, *1 no Blink'},
		{367.5, '*1 no Beat'},
		{384.5,'*1 95% dark, *2 80% stealth, *2 50% Beat'},
		{385.25,'*1 no dark, *5 40% Stealth, *1 no Blink'},
		{415.75,'*1 95% dark, *2 80% stealth, *2 50% Beat'},
		{416, '*1 no stealth, *1 no Blink, *1 no Dark, *1 no Beat'},
		{435, '*3 70% Beat'},
		{483.5,'*1 95% dark, *2 80% stealth,'},
		{484.25,'*1 no dark, *1 no stealth, *1 no Blink'},
		{515, '*1 no Beat'},

	}
	--SCREAMING GUMBALL / timed message broadcaster
	curmessage = 1;
	--{beat,message,ignoreIfAhead}
	messages = {
		{111.75, 'RotateEm'},
		{112, 'LightsOff'},
		{113, 'LightsOn'},
		
		{143.75, 'RotateEm2'},
		{144, 'LightsOff'},
		{145, 'LightsOn'},

		{303.75, 'RotateEm'},
		{304, 'LightsOff'},
		{305, 'LightsOn'},

		{335.75, 'RotateEm2'},
		{336, 'LightsOff'},
		{337, 'LightsOn'},

		{384, 'LightsOff'},
		{385, 'LightsOn'},

		{484, 'LightsOff'},
		{485, 'LightsOn'}
	}
	
end

local function Handler_update() -- Updates the command to look for the players at the start of the song.

	if GAMESTATE:GetSongBeat()>=0.1 and not checked then
		
		screen = SCREENMAN:GetTopScreen()
		
		checked = true;
		
	end

	local beat = GAMESTATE:GetSongBeat()

	-- Collect all the mods that will be applied in this frame into one string.
	-- Mod tweening doesn't work correctly if the mods are in seperate commands.
	local mods_this_frame= {}
	local function add_mod(mod_str)
		mods_this_frame[#mods_this_frame+1]= mod_str
	end
	local function execute_mods()
		if #mods_this_frame <= 0 then return end
		local total_mod_str= ""
		for i, ms in ipairs(mods_this_frame) do
			if #total_mod_str > 0 then
				total_mod_str= total_mod_str .. ", "
			end
			total_mod_str= total_mod_str .. ms
		end
		Handler_mod(total_mod_str)
	end
	
	while curmod<= #mods and GAMESTATE:GetSongBeat()>=mods[curmod][1] do
		add_mod(mods[curmod][2])
		curmod = curmod+1
	end

	execute_mods()
	
	while curmessage<= #messages and GAMESTATE:GetSongBeat()>=messages[curmessage][1] do
		if messages[curmessage][3] and GAMESTATE:GetSongBeat()>=messages[curmessage][1]+5 then
			curmessage = curmessage+1;
		else
			MESSAGEMAN:Broadcast(messages[curmessage][2])
			curmessage = curmessage+1;
		end
	end
end
local last_score_x = 0
local musicrate = GAMESTATE:GetSongOptionsObject("ModsLevel_Song"):MusicRate()
return Def.ActorFrame{

	OnCommand= function(self)
			Handler_init()
			self:SetUpdateFunction(Handler_update)
			local screen = SCREENMAN:GetTopScreen()
			if isEditMode() then 
				return;
			end
			-- Fade out everything but the SongBackground, SongForeground, and Player layers.
			-- In Simply Love (as of v4.8.5 anyway), player combos will unhide themselves,
			-- but that's okay for this stepchart.  If you need to hide combos in SL, call
			-- hibernate(math.huge) on each.  Sorry about that.
			-- don't fade out the theme's UI in EditMode
			-- Below was originally snipped From Watermelon by quietly-turning
			for name,layer in pairs(screen:GetChildren()) do
				if not (name=="SongBackground" or name=="SongForeground" or name=="Underlay" or name=="PlayerP1" or name=="PlayerP2") then
					layer:smooth(1.5):diffusealpha(0)
				end
				if (name=="SongBackground") then
					layer:visible(false)
				end
				if name == "In" then layer:visible(false) end
				if name == 'Underlay' then
					layer:visible(false)
					for player_index=1,2 do
						local score = layer:GetChild('P' .. player_index .. 'Score')					
						if score then score:visible(true):diffusealpha(1) end
					end
				end
			end

		end,
	LoadActor("Delightful Day.mp4")..{				
		InitCommand= function(self)
			self:visible(false)
			if (not isEditMode()) then
				self:visible(true)
				local src_w = self:GetTexture():GetSourceWidth()
				self:Center():zoom(_screen.w/WideScale(src_w*0.75,src_w))
				self:hibernate(0):diffusealpha(0):linear(0.3):diffusealpha(1):sleep(4):linear(0.5):diffusealpha(1)
				--Zoom the background video based on the width of the original mp4
				-- so that it fits perfectly in 16:9 and crop the sides in 4:3 borrowed' from quietly-turning's watermelon
			end
		end,
	},
	Def.Quad{
		Name= "I may be sleeping, but I preserve the world.",
		InitCommand= cmd(visible,false),
		OnCommand= cmd(sleep,1000),
			RotateEmMessageCommand= function(self)
				if P1 then
					P1:decelerate(0.6):addrotationz(360):linear(0.35):zoom(1.15)
				end
				if P2 then
					P2:decelerate(0.6):addrotationz(-360):linear(0.35):zoom(1.15)
				end
			end,
			RotateEm2MessageCommand= function(self)
				if P1 then
					P1:decelerate(0.6):addrotationz(-360):linear(0.35):zoom(1.15)
				end
				if P2 then
					P2:decelerate(0.6):addrotationz(360):linear(0.35):zoom(1.15)
				end
			end,
	},
	Def.Quad{
		OnCommand=function(self)
			if (isEditMode()) then
				self:visible(false)
			end
			self:FullScreen():Center()
			self:diffuse(0,0,0,0.2)
		end,
	},
	Def.ActorProxy {
		OnCommand = function(self)
			self:queuecommand('Set')
		end,
		SetCommand = function(self)
			if P1Score and not isEditMode() then
				self:SetTarget(P1Score)
			end
		end
	},
	Def.ActorProxy {
		OnCommand = function(self)
			self:queuecommand('Set')
		end,
		SetCommand = function(self)
			if P2Score and not isEditMode() then
				self:SetTarget(P2Score)
			end
		end
	},
	Def.ActorProxy {
		OnCommand = function(self)
			self:queuecommand('Set')
		end,
		SetCommand = function(self)
			if P1 and not isEditMode() then
				self:SetTarget(P1)
			end
		end
	},

	Def.ActorProxy {
		OnCommand = function(self)
			self:queuecommand('Set')
		end,
		SetCommand = function(self)
			if P2 and not isEditMode() then
				self:SetTarget(P2)
			end
		end
	},
	LoadActor("Delightful Day.mp4")..{
			LightsOffMessageCommand= function(self)
				self:diffusealpha(1)
				self:linear(0.75)
				self:diffusealpha(0)
			end,
			LightsOnMessageCommand= function(self)
				self:diffusealpha(0);
				if P1 then
					P1:linear(0.15):zoom(1)
				end
				if P2 then
					P2:linear(0.15):zoom(1)
				end
				self:linear(0.8);
				self:diffusealpha(0.2);
			end,
		InitCommand= function(self)
			if isEditMode() then 
				self:animate(false):loop(false):rate(musicrate):visible(false)
			else
				video = self
				local src_w = self:GetTexture():GetSourceWidth()
				self:Center():visible(true):zoom(_screen.w/WideScale(src_w*0.75,src_w))
				self:animate(false):loop(false):diffusealpha(0.2)
				self:rate( musicrate )
			end
			self:rate( musicrate )
	
		end,
		OnCommand = function(self)
			if isEditMode() then 
				self:visible(false)
			else
				local src_w = self:GetTexture():GetSourceWidth()
				self:Center():zoom(_screen.w/WideScale(src_w*0.75,src_w)):hibernate(0):diffusealpha(0):linear(0.3):diffusealpha(1):sleep(4):linear(0.5):diffusealpha(0.2)
			end
				--Zoom the background video based on the width of the original mp4
			-- so that it fits perfectly in 16:9 and crop the sides in 4:3 borrowed' from quietly-turning's watermelon
		end
	},

	
}